----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 03.03.2019 20:38:46
-- Design Name: 
-- Module Name: testbench_Data_Generator - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity testbench_Data_Generator is
--  Port ( );
end testbench_Data_Generator;

architecture Behavioral of testbench_Data_Generator is

    component Data_Generator is
        Port ( mLengthInDG : in STD_LOGIC_VECTOR (7 downto 0);
               mGenDG : in STD_LOGIC;
               rstDG : in STD_LOGIC;
               clkDG : in STD_LOGIC;
               mLengthOutDG : out STD_LOGIC_VECTOR (7 downto 0);
               mDataDG : out STD_LOGIC_VECTOR (7 downto 0);
               mValidDG : out STD_LOGIC;
               mLastDG : out STD_LOGIC);
    end component;
    
    --Inputs
    signal mLengthIn_sig : STD_LOGIC_VECTOR (7 downto 0) := "00000000";
    signal mGen_sig : STD_LOGIC := '0';
    signal rst_sig : STD_LOGIC := '0';
    signal clk_sig : STD_LOGIC := '0';
    --Outputs
    signal mLengthOut_sig : STD_LOGIC_VECTOR (7 downto 0) := "00000000";
    signal mData_sig : STD_LOGIC_VECTOR (7 downto 0) := "00000000";
    signal mValid_sig : STD_LOGIC := '0';
    signal mLast_sig : STD_LOGIC := '0';
    
    --Clock period definition
    constant clk_period : time := 20 ns; --Seal de 50Mhz
    
begin
    -- Instantiate the Unit Under Test (UUT)
    UUT: Data_Generator PORT MAP (
          mLengthInDG => mLengthIn_sig,
          mGenDG => mGen_sig,
          rstDG => rst_sig,
          clkDG => clk_sig,
          mLengthOutDG => mLengthOut_sig,
          mDataDG => mData_sig,
          mValidDG => mValid_sig,
          mLastDG => mLast_sig
        );
    
    -- Clock process definitions
    clk_process :process
    begin
        clk_sig <= '0';
        wait for clk_period/2;
        clk_sig <= '1';
        wait for clk_period/2;
    end process;
    
    -- Stimulus process
    stim_proc: process
    begin        
      -- hold reset state for 100 ns.

        --mLengthIn_sig <= "00101010";  -- 42
        mLengthIn_sig <= "00001010";    -- 10
        
        rst_sig <='1';
        wait for 50 ns;    
        rst_sig <='0';
        wait for 50 ns;
        
        mGen_sig <= '1';
        wait for 10ns;
  
        wait for clk_period*10;
    
      wait;
    end process;

end Behavioral;
