----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 10.06.2019 11:10:07
-- Design Name: 
-- Module Name: testbench_BANCO_PRUEBAS_PREEMPTION - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity testbench_BANCO_PRUEBAS_PREEMPTION is
--  Port ( );
end testbench_BANCO_PRUEBAS_PREEMPTION;

architecture Behavioral of testbench_BANCO_PRUEBAS_PREEMPTION is

    component Banco_Pruebas_Preemption is
        Port (  clkInBP : in STD_LOGIC;
                dataOutBP : out STD_LOGIC_VECTOR (7 downto 0);
                readyInBP : in STD_LOGIC;
                validOutBP : out STD_LOGIC;
                clkOutBP : out STD_LOGIC;
                rstInBP : in STD_LOGIC;
                enableInBP : in STD_LOGIC);
    end component;
    
    --Inputs
    signal clk_sig : STD_LOGIC := '0';
    signal clk_aux_sig : STD_LOGIC := '0';
    signal ready_sig : STD_LOGIC := '0';
    signal enable_sig :  STD_LOGIC := '0';
    signal rst_sig :  STD_LOGIC := '0'; 
    --Outputs
    signal data_sig : STD_LOGIC_VECTOR (7 downto 0) := "00000000";
    signal valid_sig : STD_LOGIC := '0';
    
    --Clock period definition
    constant clk_period : time := 20 ns; --Seal de 50Mhz

begin
    -- Instantiate the Unit Under Test (UUT)
    UUT: Banco_Pruebas_Preemption PORT MAP (
          clkInBP => clk_sig,
          dataOutBP => data_sig,
          readyInBP => ready_sig,
          validOutBP => valid_sig,
          clkOutBP => clk_aux_sig,
          rstInBP => rst_sig,
          enableInBP => enable_sig
        );

                       
    
    -- Clock process definitions
    clk_process :process
    begin
        clk_sig <= '0';
        wait for clk_period/2;
        clk_sig <= '1';
        wait for clk_period/2;
    end process;
    
    -- Stimulus process
    stim_proc: process
    begin        
      -- hold reset state for 100 ns.
        
        rst_sig <='1';
        wait for clk_period*2;   
        rst_sig <='0';
        wait for clk_period*2;
        
        
        enable_sig <= '1';
        wait for clk_period*2;
        
        ready_sig <= '1';
        wait for clk_period*2;
        
        wait for clk_period*200;
    
      wait;
    end process;


end Behavioral;
