----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 15.03.2019 16:18:25
-- Design Name: 
-- Module Name: testbench_control_tipo_paquete - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity testbench_control_tipo_paquete is
--  Port ( );
end testbench_control_tipo_paquete;

architecture Behavioral of testbench_control_tipo_paquete is

    component control_tipo_paquete is
        Port ( rst : in STD_LOGIC;
               clk : in STD_LOGIC;
               enable : in STD_LOGIC;
               mSel : out STD_LOGIC_VECTOR (1 downto 0));
    end component;
    
    -- Inputs
    signal rst_sig: std_logic;
    signal clk_sig: std_logic;
    signal enable_sig: std_logic;

    -- Outputs
    signal mSel_sig: std_logic_vector (1 downto 0);
    
    --Clock period definition
    constant clk_period : time := 20 ns; --Seal de 50Mhz      
        
begin
    -- Instantiate the Unit Under Test (UUT)
    UUT: control_tipo_paquete PORT MAP (
          rst => rst_sig,
          clk => clk_sig,
          enable => enable_sig,
          mSel => mSel_sig
           );
    
    -- Clock process definitions
    clk_process :process
    begin
        clk_sig <= '0';
        wait for clk_period/2;
        clk_sig <= '1';
        wait for clk_period/2;
    end process;
    
    -- Stimulus process
    stim_proc: process
    begin        
      -- hold reset state for 100 ns.
        
        rst_sig <='1';
        wait for 50 ns;    
        rst_sig <='0';
        wait for 50 ns;
        
        enable_sig <= '1';   
        wait for clk_period*50;
    
      wait;
    end process;

end Behavioral;
